#include <stdio.h>
#include <string.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include <avr/iocan128.h>
#include <avr/iocanxx.h>
#include <avr/io.h>
#include <stdlib.h>
#include <util/delay.h>
#include <avr/eeprom.h>
#include <avr/wdt.h>

#include "can.h"


volatile unsigned char can_flag;/*variable for can interrupt*/

/*define CAN-structur */
struct canStruct canFrame;
struct canStruct *ptr_canStruct;
/*define can-Send-structur */
struct MOb1 Msg1;
struct MOb1 *msg1;

struct MOb2 Msg2;
struct MOb2 *msg2;
int b;


int main(void)
{
	
	
	ptr_canStruct = &canFrame;  /* initialize pointer for CAN-struct */
	msg1 = &Msg1; /* initialize pointer for CAN-Send1 */
	msg2 = &Msg2; /* initialize pointer for CAN-Send2 */
	/* 1 Message to send*/
	msg1->mob1 = 1;
	msg1->length1 = 8;
	msg1->id1 = 0X304;   
	msg1->data1[0] = 0X00;
	msg1->data1[1] = 0X00;
	msg1->data1[2] = 0x00;
	msg1->data1[3] = 0x00;
	msg1->data1[4] = 0x00;
	msg1->data1[5] = 0x00;
	msg1->data1[6] = 0x00;
	msg1->data1[7] = 0x00;
	/* 2 Message to send*/
	msg2->mob2 = 1;
	msg2->length2 = 8;
	msg2->id2 = 0X384;   
	msg2->data2[0] = 0X00;
	msg2->data2[1] = 0X00;
	msg2->data2[2] = 0x00;
	msg2->data2[3] = 0x00;
	msg2->data2[4] = 0x00;
	msg2->data2[5] = 0x00;
	msg2->data2[6] = 0x00;
	msg2->data2[7] = 0x00;
	/* initialize flag */
	can_flag = 0;
	
	cli();  /*interrupt disable */
	UART0_Init(); /* initialize serial interface */
	can_init();   /* initialize can-contoller with a baudrate 250kps */
	
	Can_transmit1(msg1);
	for(double i = 0; i < 25000; i++)
	{	
		b++;		
	}
	Can_transmit2(msg2);

	sei(); /*interrupt enable */
       
	
	
	while( 1 ) 
	{
		
		if( 1 == can_flag  ) /* of the ISR data has been fully received */
		{   
			cli();
			Convert_pack_canFrame_to_UartFormat(ptr_canStruct);
			can_flag = 0; /* restore flag */
			sei();
		}          
	
	}
}	

	




